Subject: Re: [Patch net-next 2/4] net_sched: update hierarchical backlog too

From: Jamal Hadi Salim <[email-masked]>
Date: Fri, 16 Oct 2015 08:22:15 -0400

On 10/15/15 00:32, Cong Wang wrote:
> On Wed, Oct 14, 2015 at 5:11 AM, Jamal Hadi Salim <[email-masked]> wrote:
>> On 10/12/15 14:38, Cong Wang wrote:
>>>
>>> When the bottom qdisc decides to, for example, drop some packet,
>>> it calls qdisc_tree_decrease_qlen() to update the queue length
>>> for all its ancestors, we need to update the backlog too to
>>> keep the stats on root qdisc accurate.
>>>
>>
>>
>> There is more than one change in there (the codel change seems
>> out of place and i wasnt sure why it was needed).
>
> I thought it is clear that when codel decides to drop some packets
> we don't know how many bytes it drops, we only know how many
> packets before my patch. For example,
>
> -               qdisc_tree_decrease_qlen(sch, q->cstats.drop_count);
> +               qdisc_tree_reduce_backlog(sch, q->cstats.drop_count,
> +                                         q->cstats.drop_len);
>
> This clearly means I need some codel stats from codel to pass to
> qdisc_tree_reduce_backlog(), this is  why the codel part is
> necessary.
>
>
>> Also it seems possible you are double-dipping in some cases;
>> i dont have time to scrutinize - but looking at codel_change() change
>> when the queue limit is exceeded you will end up affecting backlog from
>> both qdisc_qstats_backlog_dec() and your new
>> qdisc_tree_reduce_backlog()
>
> Nope, qdisc_qstats_backlog_dec() decreases the backlog of itself,
> qdisc_tree_reduce_backlog() decreases its upper qdiscs'. It is correct
> as it was.
>

Didnt look closer - will take your word for it.

Acked-by: Jamal Hadi Salim <[email-masked]>

cheers,
jamal